'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var jQuery = require('jquery');

function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n["default"] = e;
    return Object.freeze(n);
}

var jQuery__namespace = /*#__PURE__*/_interopNamespace(jQuery);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

var SignerService = /** @class */ (function () {
    function SignerService() {
        //
    }
    Object.defineProperty(SignerService.prototype, "authorization", {
        get: function () {
            return sessionStorage.getItem('signer.auth') || this.signerAuthorization;
        },
        enumerable: false,
        configurable: true
    });
    SignerService.prototype.setLastCertificate = function (thumbprint) {
        return sessionStorage.setItem('signer.lastCertificate', thumbprint);
    };
    SignerService.prototype.getLastCertificate = function () {
        return sessionStorage.getItem('signer.lastCertificate');
    };
    SignerService.prototype.destroy = function () {
        if (this.signerAuthorization) {
            this.signerAuthorization = null;
        }
    };
    SignerService.prototype.getInspectorUrl = function () {
        return new URL('/signature/inspect', SignerService.SINGER_URI).toString();
    };
    SignerService.prototype.inspectPosition = function (blob, configuration) {
        return __awaiter(this, void 0, void 0, function () {
            var formData, headers;
            var _this = this;
            return __generator(this, function (_a) {
                formData = new FormData();
                // set name
                if (configuration.text != null) {
                    configuration.text.forEach(function (value) {
                        formData.append('text', encodeURIComponent(value));
                    });
                }
                if (configuration.textPosition != null) {
                    formData.append('textPosition', configuration.textPosition);
                }
                if (configuration.width != null) {
                    formData.append('width', configuration.width.toFixed(0));
                }
                if (configuration.height != null) {
                    formData.append('height', configuration.height.toFixed(0));
                }
                // set file
                formData.append('file', blob, 'inspect-position.pdf');
                headers = {};
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        void jQuery__namespace.ajax({
                            url: _this.getInspectorUrl(),
                            headers: headers,
                            method: 'POST',
                            crossDomain: true,
                            data: formData,
                            dataType: 'text',
                            xhrFields: {
                                withCredentials: true
                            }
                        }).done(function (data) {
                            return resolve(data);
                        }).fail(function (jqXHR, textStatus, errorThrown) {
                            var error = new Error(errorThrown);
                            Object.assign({
                                status: jqXHR.status
                            });
                            return reject(error);
                        });
                    })];
            });
        });
    };
    SignerService.SINGER_URI = 'http://localhost:2465/';
    SignerService.DEFAULT_SIGN_POSITION = '20,10,320,120';
    return SignerService;
}());

var UsernameAndPassword = /** @class */ (function () {
    function UsernameAndPassword(value) {
        this.value = value;
        //
    }
    Object.defineProperty(UsernameAndPassword.prototype, "username", {
        get: function () {
            var decrypted = atob(this.value.replace(/^Basic\s/g, ''));
            var separator = decrypted.indexOf(':');
            return decrypted.substr(0, separator);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(UsernameAndPassword.prototype, "password", {
        get: function () {
            var decrypted = atob(this.value.replace(/^Basic\s/g, ''));
            var separator = decrypted.indexOf(':');
            return decrypted.substr(separator + 1);
        },
        enumerable: false,
        configurable: true
    });
    UsernameAndPassword.create = function (username, password) {
        return 'Basic ' + btoa("".concat(username, ":").concat(password));
    };
    return UsernameAndPassword;
}());

var DocuSignSignerService = /** @class */ (function (_super) {
    __extends(DocuSignSignerService, _super);
    function DocuSignSignerService(config) {
        var _this = _super.call(this) || this;
        _this.config = config;
        _this.certificates = null;
        return _this;
    }
    DocuSignSignerService.prototype.requestVerificationCode = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            void jQuery__namespace.ajax({
                url: new URL('requestCode', _this.config.serviceRoot).toString(),
                method: 'POST',
                headers: {
                    'Authorization': _this.authorization
                },
                crossDomain: true,
                dataType: 'json',
                xhrFields: {
                    withCredentials: false
                }
            }).done(function (result) {
                if (result === 1) {
                    return resolve(false);
                }
                if (result === 9) {
                    return reject(new Error('An error occurred while sending verification code'));
                }
                return resolve(true);
            }).fail(function (jqXHR, textStatus, errorThrown) {
                var error = new Error(errorThrown);
                Object.assign({
                    status: jqXHR.status
                });
                return reject(error);
            });
        });
    };
    Object.defineProperty(DocuSignSignerService.prototype, "requiresVerificationCodeRequest", {
        get: function () {
            return true;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DocuSignSignerService.prototype, "status", {
        get: function () {
            throw new Error('Method not implemented.');
        },
        enumerable: false,
        configurable: true
    });
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    DocuSignSignerService.prototype.authenticate = function (_a) {
        var _this = this;
        var username = _a.username, password = _a.password; _a.rememberMe;
        this.certificates = [];
        return new Promise(function (resolve, reject) {
            var tryAuthorize = UsernameAndPassword.create(username, password);
            void jQuery__namespace.ajax({
                url: new URL('keystore/certs', _this.config.serviceRoot).toString(),
                headers: {
                    'Authorization': tryAuthorize
                },
                method: 'GET',
                crossDomain: true,
                dataType: 'json',
                xhrFields: {
                    withCredentials: false
                }
            }).done(function (certificates) {
                _this.signerAuthorization = tryAuthorize;
                _this.certificates = certificates;
                return resolve(true);
            }).fail(function (jqXHR, textStatus, errorThrown) {
                var error = new Error(errorThrown);
                Object.assign({
                    status: jqXHR.status
                });
                return reject(error);
            });
        });
    };
    DocuSignSignerService.prototype.getCertificates = function (force) {
        var _this = this;
        if (force) {
            this.certificates = null;
        }
        if (Array.isArray(this.certificates)) {
            return Promise.resolve(this.certificates);
        }
        return new Promise(function (resolve, reject) {
            void jQuery__namespace.ajax({
                url: new URL('keystore/certs', _this.config.serviceRoot).toString(),
                headers: {
                    'Authorization': _this.authorization
                },
                method: 'GET',
                crossDomain: true,
                dataType: 'json',
                xhrFields: {
                    withCredentials: false
                }
            }).done(function (cert) {
                _this.certificates = [];
                if (cert) {
                    _this.certificates.push(cert);
                }
                return resolve(_this.certificates);
            }).fail(function (jqXHR, textStatus, errorThrown) {
                var error = new Error(errorThrown);
                Object.assign({
                    status: jqXHR.status
                });
                return reject(error);
            });
        });
    };
    DocuSignSignerService.prototype.queryStatus = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            void jQuery__namespace.ajax({
                url: new URL('keystore/certs', _this.config.serviceRoot).toString(),
                method: 'OPTIONS',
                crossDomain: true,
                xhrFields: {
                    withCredentials: false
                }
            }).done(function () {
                return resolve(true);
            }).fail(function (jqXHR, textStatus, errorThrown) {
                var error = new Error(errorThrown);
                Object.assign({
                    status: jqXHR.status
                });
                return reject(error);
            });
        });
    };
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    DocuSignSignerService.prototype.sign = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, new Promise(function (resolve, reject) {
                            void jQuery__namespace.ajax({
                                url: new URL('sign', _this.config.serviceRoot).toString(),
                                method: 'POST',
                                cache: false,
                                contentType: false,
                                processData: false,
                                headers: {
                                    'Authorization': _this.authorization
                                },
                                crossDomain: true,
                                data: form,
                                xhrFields: {
                                    withCredentials: false,
                                    responseType: 'blob'
                                }
                            }).done(function (data) {
                                return resolve(data);
                            }).fail(function (jqXHR, textStatus, errorThrown) {
                                var error = new Error(errorThrown);
                                Object.assign({
                                    status: jqXHR.status
                                });
                                return reject(error);
                            });
                        })];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    Object.defineProperty(DocuSignSignerService.prototype, "requiresVerificationCode", {
        get: function () {
            return true;
        },
        enumerable: false,
        configurable: true
    });
    DocuSignSignerService.prototype.confirmVerificationCode = function () {
        throw new Error('Method not implemented.');
    };
    Object.defineProperty(DocuSignSignerService.prototype, "requiresUsernamePassword", {
        get: function () {
            return true;
        },
        enumerable: false,
        configurable: true
    });
    DocuSignSignerService.prototype.getVerificationUrl = function () {
        throw new Error('Method not implemented.');
    };
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    DocuSignSignerService.prototype.verifyDocument = function (file) {
        throw new Error('Method not implemented.');
    };
    return DocuSignSignerService;
}(SignerService));

// noinspection JSUnusedGlobalSymbols
jQuery__namespace.fn.extend({
    signer: function signer(service) {
        // eslint-disable-next-line @typescript-eslint/no-this-alias,@typescript-eslint/no-unsafe-assignment
        var element = this;
        if (service === 'getService') {
            return element.data('SignerService');
        }
        element.data('SignerService', service);
        return element;
    }
});

exports.DocuSignSignerService = DocuSignSignerService;
exports.SignerService = SignerService;
//# sourceMappingURL=index.cjs.js.map
